com.io7m.jpra.model.size_expressions

## Class SizeExprInBits<I,T>

- java.lang.Object
- - com.io7m.jpra.model.size_expressions.SizeExprInBits<I,T>

- Type Parameters:
    `I` - The type of identifiers
    `T` - The type of type information
  All Implemented Interfaces:
    ModelElementType, SizeExprType<I,T>

      @Immutable
      public final class SizeExprInBits<I,T>
      extends Object
      implements SizeExprType<I,T>

  A size function denoting the size in bits of a given type expression.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SizeExprInBits(TypeExprType<I,T> in_expression)` Construct an expression.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Optional<com.io7m.jlexing.core.LexicalPosition<Path>>` | `getLexicalInformation()` Fetch the lexical information for the element.
    `TypeExprType<I,T>` | `getTypeExpression()`
    `<A,E extends Exception> A` | `matchSizeExpression(SizeExprMatcherType<I,T,A,E> m)` Accept a matcher.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SizeExprInBits

          public SizeExprInBits(TypeExprType<I,T> in_expression)

      Construct an expression.
      Parameters:
        `in_expression` - The type expression

  - ### Method Detail

    - #### getTypeExpression

          public TypeExprType<I,T> getTypeExpression()

      Returns:
        The type expression

    - #### matchSizeExpression

          public <A,E extends Exception> A matchSizeExpression(SizeExprMatcherType<I,T,A,E> m)
                                                        throws E extends Exception

      Description copied from interface: `SizeExprType`
      Accept a matcher.
      Specified by:
        `matchSizeExpression` in interface `SizeExprType<I,T>`
      Type Parameters:
        `A` - The type of returned values
        `E` - The type of raised exceptions
      Parameters:
        `m` - The matcher
      Returns:
        The value returned by `m`
      Throws:
        `E` - If `m` raises `E`
        `E extends Exception`

    - #### getLexicalInformation

          public Optional<com.io7m.jlexing.core.LexicalPosition<Path>> getLexicalInformation()

      Description copied from interface: `ModelElementType`
      Fetch the lexical information for the element. This is used to localize error messages to a position in a file when referring to specific elements.
      Specified by:
        `getLexicalInformation` in interface `ModelElementType`
      Returns:
        The original lexical information, if any

Copyright © 2017 <code@io7m.com> http://io7m.com